/*
 * Copyright (c) 1993-1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * The Java source code is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.

 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */
/*
 * @(#)interrupt_md.h	1.6 95/11/29  
 *
 */

/*
 * Solaris interrupts
 */

#ifndef	_SOLARIS_INTERRUPT_MD_H_
#define	_SOLARIS_INTERRUPT_MD_H_

/*
 * Header files.
 */
#include "bool.h"

/*
 * Number of interrupt channels.
 */
#define	N_INTERRUPTS	32	/* 0 to 31 */

/*
 * Routines/Macros that actually set/get the processor interrupt level.
 */
extern void 	intrLock(void);
extern void 	intrUnlock(void);
extern bool_t 	intrIsLocked(void);

#endif	/* !_SOLARIS_INTERRUPT_MD_H_ */
